from .data import DataSeq
import random


def Qsort(ds, Left, Right):
##    print("排序：", ds, "Left", Left, "Right", Right)
    Cutoff = 10
    if Cutoff <= Right-Left:
        mid_index = random.randint(0, Right - Left) + Left # 根据参数的个数生成随机数Right - Left
        Pivot = ds.data[mid_index] # 找到基准值
##        print("随机值是：", Pivot)
##        Pivot = ds.data[Left]
        low = Left + 1 # 分区后，最左面位置留给基准值置换使用
        high = Right

        
##        # 将随机出来的数放到第0个位置就可以使用传统的快排代码了
##        temp = ds.data[Left]
##        ds.SetVal(Left, Pivot)
##        ds.SetVal(mid_index, temp)
        
        ds.Swap(Left, mid_index)
        
##        print("调整随机数到第一位后：\t", ds)
                
        while True:
            while ds.data[high] > Pivot: # 循环+列表等于判断，当右侧找到小于基准值的元素时，列表的位置是high
                high -= 1
##                ds.Visualize((), (high,))
            while ds.data[low] < Pivot:
                low += 1
##                ds.Visualize((), (low,))

            if low < high:
                ds.Swap(low, high)
                low += 1
                high -= 1                
            else:
                break

        ds.Swap(Left, high) # 用右游标置换左端的基准值选取位，这里很巧妙，因为开端选的左端，是放小元素的，所以要用右游标
                            # 同理，如果开端选择把最终置换的随机数保存在右端，那么最后交换就要用左游标
##        print("一轮之后：\t\t", ds)

        Qsort(ds, Left, high-1)
        Qsort(ds, high+1, Right)

    else:
##        print("进入插入排序")
        # 元素太少，用插入排序
        for p in range(Left,Right+1):
            tmp = ds.data[p]
            i=p
            while i>=1 and ds.data[i-1]>tmp:
                ds.SetVal(i, ds.data[i-1])
                i-=1
            ds.SetVal(i, tmp)

def RandomQuickDoubleSort(ds):
    assert isinstance(ds, DataSeq), "Type Error"

    Length = ds.length
    Qsort(ds, 0, Length-1)

if __name__ == "__main__":
    ds=DataSeq(64)
    print(ds)
    ds.Visualize()
    ds.StartTimer()
    ds.SetTimeInterval(1)
    RandomQuickDoubleSort(ds)
    ds.StopTimer()
    print(ds)
    ds.Visualize()
